module Reader
(
  module Reader,
  ReaderT
) where


import Control.Monad.Reader


(>>=^)
  :: (Monad m)
  => m r -> ReaderT r m b -> m b
m >>=^ ReaderT k
  = m >>= k

with
  :: (Monad m)
  => (r -> s) -> ReaderT s m a -> ReaderT r m a
with
  = withReaderT

follow
  :: (Monad m)
  => (r -> m a) -> ReaderT r m a
follow
  = ReaderT

always
  :: (Monad m)
  => m a -> ReaderT r m a
always
  = follow . const

