module Swap.Var
(
  module Swap.Var,
  module Var
)
where


import Var


data instance Var Int
  = X | Y
  deriving (Show, Bounded, Eq, Ord)


instance Enum (Var Int) where

  fromEnum X
    = 0
  fromEnum _
    = 1

  toEnum 0
    = X
  toEnum 1
    = Y
  toEnum _
    = error "toEnum: no corresponding value"


instance Ix (Var Int) where

  range (a , b)
    = [a .. b]

  inRange (a , b) x
    = a <= x && x <= b

  index (a , b) x
    | inRange (a , b) x
      = fromEnum x - fromEnum a
    | otherwise
      = error "index: out of range"


